# This file is protected by Copyright. Please refer to the COPYRIGHT file
# distributed with this source distribution.
#
# This file is part of OpenCPI <http://www.opencpi.org>
#
# OpenCPI is free software: you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
# details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.


""" This file interfaces above with the Project class and below with the
    all the things component libraries are composed of
    (Component/Protocol/Worker/etc)."""


import os
from _opencpi.assets.abstract2 import *
from _opencpi.assets.abstract2 import AssetBase
from _opencpi.assets.component2 import Component, Protocol, test_Component
from _opencpi.assets.worker2 import Worker, RccAssembly
from _opencpi.assets.worker2 import test_Worker, test_RccAssembly
from _opencpi.assets.test2 import Test


comps_rst_template = """.. Component directory index page


Components
==========
Available component libraries.

.. toctree::
   :maxdepth: 2
   :glob:

   */*
   */*-library

.. Make sure that any subsidiary files that are included into an asset document,
   whether or not they are local, are named with the suffix .inc, not .rst.
   Using the .inc suffix for subsidiary included files is currently necessary
   to prevent them from being mistakenly generated by the asset documentation
   system during a documentation build operation.
   
.. The search path "*/*-library" is for backward compatibility with older
   component document naming schemes.

"""  # nopep8


comp_lib_rst_template = """
.. {{asset.name|capitalize}} library index page


{{asset.name|capitalize}} Library
=================================
Skeleton outline: Component library description and outline of scope to go here.

.. toctree::
   :maxdepth: 1
   :glob:
   :caption: {{asset.name}}

   *.comp/*-index
   *.comp/*-comp

..
   "*.comp/*-index" is for backward compatibility with older component document naming schemes.

"""  # noqa: E501


class SpecsDirectory():
    """ Class which represents a specs directory, including its components and
        protocols """

    def __init__(self):
        self.components = []
        self.protocols = []

    def discover(self):
        for _dir in os.listdir(self.abs_path):
            if _dir == 'specs':
                discovery_path = self.abs_path + '/' + _dir
                for name in AssetBase.listdir_assets(discovery_path):
                    path = discovery_path + '/' + name
                    for _type in [Component, Protocol]:
                        try:
                            self.append_discovered_asset(_type(path))
                        except InvalidAssetError:
                            pass


class ComponentLibrariesDirectory(AssetBase):
    """ undocumented """

    def __init__(self, dir_abs_path, cli_dict=None):
        self.root_tags = ['Libraries']  # undocumented
        if not dir_abs_path.endswith('components'):
            self.raise_invalid_asset_error()
        AssetBase.__init__(self, dir_abs_path, cli_dict)
        if cli_dict is None:
            if os.path.exists(self.get_xml_abs_path()):
                # TODO investigate moving into AssetBase
                self.raise_if_invalid_root_tag(self.get_parsed().getroot())
            found = True
            for entry in AssetBase.listdir_assets(self.get_dir_abs_path()):
                if entry == 'specs':
                    found = False
            if not found:
                self.raise_invalid_location()
        self.parse()

    def get_templates(self):
        templates = {}
        templates[self.name + '.rst'] = comps_rst_template
        templates[self.name + '.xml'] = g_asset_template
        return templates

    def get_paths_to_parse(self):
        return [self.get_xml_abs_path()]

    def get_type(self):
        return 'component libraries'


class ComponentLibrary(AssetBase, ComponentLibraryWorkerBase,
                       ComponentLibraryProjectBase,
                       ComponentLibraryWorkerProjectAssemblyBase,
                       HdlLibraryComponentLibraryWorkerBase,
                       SpecsDirectory):
    """ Reference RCC/HDL Development Guide section 3. A ComponentLibrary is
        represented by a directory and knows nothing about the project it
        is in or its package ID. """
    # start of CDG section 14.2.3
    valid_locations = ['components', 'hdl/devices', 'hdl/cards']
    valid_locations += ['hdl/adapters', 'hdl/platforms', 'devices']
    # end of CDG section 14.2.3

    def __init__(self, dir_abs_path, cli_dict=None):
        """ cli_dict must be None when discovering existing libraries on the
            filesystem, and when not None, must be a dict containing
            entries according to
            get_attr_infos (e.g. 'hdllibraries') """
        self.root_tags = ['Library']  # CDG section 10.1
        AssetBase.__init__(self, dir_abs_path, cli_dict)
        is_test = self.get_dir_abs_path_is_test(dir_abs_path)
        if is_test or self.get_dir_abs_path_is_worker(dir_abs_path):
            self.raise_invalid_asset_error()
        SpecsDirectory.__init__(self)
        # start of bullets at top of CDG section 10
        self.components = []
        self.protocols = []
        self.workers = []
        self.tests = []
        # end of bullets at top of CDG section 10
        # start of CDG section 14.5 (XML)
        self.component_libraries = []
        self.hdl_libraries = []
        # end of CDG section 14.5
        self.parse(cli_dict)
        workers = self.attrs['Workers']
        allowlist = None if workers == [] else workers
        if cli_dict is None:
            self.discover(allowlist, 'hdl/platforms' in dir_abs_path)

    def get_type(self):
        """ this string is used in many places to disambiguate the duck-typed
            asset object (similar to type())"""
        return 'component library'

    @staticmethod
    def get_dir_abs_path_is_worker(dir_abs_path):
        ret = False
        # TODO remove 'comp' from list
        for ext in ['rcc', 'hdl', 'ocl', 'comp']:
            if dir_abs_path.endswith('.' + ext):
                ret = True
        return ret

    @staticmethod
    def get_dir_abs_path_is_test(dir_abs_path):
        return dir_abs_path.endswith('.test')

    def get_attr_infos(self):
        """ returns a dictionary which is the authoritative definition of what
            attributes exist for this asset, what their types are (dictates how
            they should be parsed), and what their exposes CLI arguments
            are """
        ret = []
        ret.extend(ComponentLibraryWorkerBase.get_attr_infos(self))
        ret.extend(ComponentLibraryProjectBase.get_attr_infos(self))
        tmp = ComponentLibraryWorkerProjectAssemblyBase.get_attr_infos(self)
        ret.extend(tmp)
        ret.extend(HdlLibraryComponentLibraryWorkerBase.get_attr_infos(self,
                                                                       True))
        ret.append(AttributeInfo('XmlIncludeDirs',
                   cli=('-A', '--xml-include'),
                   is_list=True))  # CDG section 10.1
        # --- IMPORTANT --- BELOW LINE IS NOT MENTIONED IN DEV GUIDE
        #                   BUT DOES EXIST IN misc_comps/Library.mk
        ret.append(AttributeInfo('HdlLibraries', is_list=True))
        # below line mentioned in HGD section 4
        ret.append(AttributeInfo('Workers', is_list=True))
        ret.append(AttributeInfo('PackagePrefix',
                                 cli=('-F', '--package-prefix')))
        ret.append(AttributeInfo('PackageID', cli=('-K', '--package-id')))
        ret.append(AttributeInfo('PackageName', cli=('-N', '--package-name')))
        return ret

    def get_paths_to_parse(self):
        """ return list of strings which define all files of this asset type
            which potentially contain attributes (usually the xml, sometimes
            also makefile(s)) for pre-2.0 opencpi project support """
        paths = []
        # start pre-2.0 opencpi
        # TODO address library.mk vs libraries.mk behavior in Makefile
        paths += [self.abs_path + '/Library.mk', self.abs_path + '/Makefile']
        # intentionally put xml last so that its attributes take precedence
        # end pre-2.0 opencpi
        paths.append(self.get_xml_abs_path())
        paths = self.get_list_of_existing_abs_paths_to_parse(paths)
        return paths

    def get_templates(self):
        """ Returns dictionary containing keys which are filenames and values
            which are jiinja template strings. The dictionary is the authority
            on what gets created for the 'create' verb """
        templates = {}
        templates[self.name + '-library.rst'] = comp_lib_rst_template
        templates[self.name + '.xml'] = g_asset_template
        return templates

    def parse(self, cli_dict=None):
        """ during discovery, parse the assumed-existing files indicated in
            get_paths_to_parse() for the attributes of this asset """
        AssetBase.parse(self, cli_dict)
        global g_libraries_mk
        if g_libraries_mk:
            g_libraries_mk = False

    def create(self):
        """ create this asset by writing files to the filesystem """
        AssetBase.create(self)
        # below line is so that protocols can be created
        System('mkdir -p ' + self.get_dir_abs_path() + '/specs')

    def discover(self, allowlist, platform=False):
        """ discover this asset as it exists, already, on the filesystem """
        SpecsDirectory.discover(self)
        self.discover_workers_and_tests(allowlist, platform)
        for discovery_path in self.get_potential_asset_dir_abs_paths(''):
            if discovery_path.endswith('.comp'):  # undocumented
                for entry in AssetBase.listdir_assets(discovery_path):
                    try:
                        asset = Component(discovery_path + '/' + entry)
                        self.append_discovered_asset(asset)
                    except InvalidAssetError:
                        pass

    def discover_workers_and_tests(self, allowlist, platform=False):
        # Logger().debug(str(allowlist))
        # '' in below line indicates worker discovery
        self.discover_dir_assets('', allowlist, platform)

    def append_discovered_asset(self, asset):
        if asset.get_type() == 'component':
            self.components.append(asset)
        if asset.get_type() == 'protocol':
            self.protocols.append(asset)
        _type = asset.get_type()
        if (_type == 'hdl worker') or (_type == 'rcc worker'):
            self.workers.append(asset)
        if asset.get_type() == 'test':
            self.tests.append(asset)
        Logger().log(9, 'discovered ' + _type + ' ' + asset.abs_path)

    def get_potential_asset_dir_abs_paths(self, parent):
        ret = []
        discovery_path = self.abs_path + '/' + parent
        if os.path.isdir(discovery_path):
            for _dir in AssetBase.listdir_assets(discovery_path):
                dir_abs_path = discovery_path + '/' + _dir
                allowable_dir = (_dir != 'specs') and (_dir != 'gen')
                if os.path.isdir(dir_abs_path) and allowable_dir:
                    ret.append(dir_abs_path)
        return ret

    def discover_dir_assets(self, parent, allowlist=None, platform=False):
        for dir_abs_path in self.get_potential_asset_dir_abs_paths(parent):
            try:
                assets = []
                tmp = dir_abs_path
                if tmp.endswith('.rcc') or tmp.endswith('.hdl') or \
                   tmp.endswith('.test') or platform:
                    name = AssetBase.get_name_from_abs_path(dir_abs_path)
                    if tmp.endswith('.rcc'):
                        # due to edge cases such as testzc.rcc, testmulti.rcc
                        assets = RccAssembly(dir_abs_path).workers
                    elif tmp.endswith('.hdl'):
                        tmp = dir_abs_path + '/' + name + '.xml'
                        assets.append(Worker(tmp))
                    elif tmp.endswith('.test'):
                        assets.append(Test(dir_abs_path))
                for asset in assets:
                    if allowlist is not None:
                        # TODO is this pre-2.0???
                        allowlist = [name.split('.')[0] for name in allowlist]
                    if (allowlist is None) or (asset.name in allowlist):
                        self.append_discovered_asset(asset)
            except InvalidAssetError as err:
                if (parent != 'applications') and \
                   (not dir_abs_path.endswith('.test')):
                    Logger().warn('skipping ' + str(err))
                pass


def test_ComponentLibrary(ret):
    ret = test_Component(ret)
    ret = test_RccAssembly(ret)
    ret = test_Worker(ret)
    fs = TemporaryFilesystem()
    for test in range(7):
        passed = True
        try:
            dir_abs_path = fs.abs_path + '/' + 'components'
            os.system('mkdir -p ' + dir_abs_path + '/' + 'foo.comp')
            ff = open(dir_abs_path + '/' + 'components.xml', 'w')
            ff.write('<Library/>\n')
            ff.close()
            ff = open(dir_abs_path + '/foo.comp' + '/' + 'mycomp.xml', 'w')
            ff.write('<ComponentSpec/>\n')
            ff.close()
            uut = ComponentLibrary(dir_abs_path)
            if test == 0:
                passed = uut.abs_path == dir_abs_path
            if test == 1:
                passed = uut.name == 'components'
            if test == 2:
                passed = len(uut.components) == 1
            if test == 3:
                passed = uut.workers == []
            if test == 4:
                passed = uut.tests == []
            if test == 5:
                passed = uut.component_libraries == []
        except InvalidAssetError:
            passed = False
        if test == 0:
            log_pass_fail('testing ComponentLibrary abs_path', passed)
        if test == 1:
            log_pass_fail('testing ComponentLibrary name', passed)
        if test == 2:
            log_pass_fail('testing ComponentLibrary components', passed)
        if test == 3:
            log_pass_fail('testing ComponentLibrary workers', passed)
        if test == 4:
            log_pass_fail('testing ComponentLibrary tests', passed)
        if test == 5:
            tmp = passed
            log_pass_fail('testing ComponentLibrary component_libraries', tmp)
        if passed is False:
            ret = False
    return ret
